/* Output from p2c, the Pascal-to-C translator */
/* From input file "M2/DynArray.mi" */


/* $Id: DynArray.mi,v 1.4 90/03/02 17:36:10 grosch rel $ */

/* Eliminated all aligment--- C malloc should do it already */

/* $Log:        DynArray.mi,v $
 * Revision 1.4  90/03/02  17:36:10  grosch
 * automized handling of machine independent alignment
 *
 * Revision 1.3  90/02/28  22:07:00  grosch
 * comment for alignment on SPARC
 *
 * Revision 1.2  89/12/08  20:12:44  grosch
 * introduced a machine dependent variant for MIPS
 *
 * Revision 1.1  88/10/18  16:30:08  grosch
 * fixed bug: invariant must hold: ElmtCount * ElmtSize MOD 4 = 0
 *
 * Revision 1.0  88/10/04  11:46:52  grosch
 * Initial revision
 *
 */

/* Ich, Doktor Josef Grosch, Informatiker, Sept. 1987 */


#include <p2c/p2c.h>


#ifndef Memory_H
#include "Memory.h"
#endif


/* INVARIANT ElmtCount * AlignedSize (ElmtSize) MOD TSIZE (LONGINT) = 0 */

unsigned long *DynArray_MakeCardArray(unsigned long ElmtCount)
{
    return ((unsigned long *)malloc(ElmtCount * sizeof(unsigned long)));
}


long *DynArray_MakeIntArray(unsigned long ElmtCount)
{
    return ((long *)malloc(ElmtCount * sizeof(long)));
}


float *DynArray_MakeRealArray(unsigned long ElmtCount)
{
    return ((float *)malloc(ElmtCount * sizeof(float)));
}


double *DynArray_MakeDoubleArray(unsigned long ElmtCount)
{
    return ((double *)malloc(ElmtCount * sizeof(double)));
}


void DynArray_ExtendArray(void **ArrayPtr, unsigned long *ElmtCount,
			  unsigned long ElmtSize)
{
    unsigned long NewCount;

    NewCount = *ElmtCount * 2;
    *ArrayPtr = realloc(*ArrayPtr, NewCount * ElmtSize);
}


void DynArray_FreeArray(void **ArrayPtr)
{
    free(*ArrayPtr);

    *ArrayPtr = 0;
}





/* End. */
