/* Output from p2c, the Pascal-to-C translator */
/* From input file "M2/IO.mi" */


#include <p2c/p2c.h>


/*
   A replacement for the I/O library used by the german guys, now
   designed to use the features in p2c.
   Does FORMATTED I/O!!
 */

Static FILE *ftemp;


/*
   For some reason (a bug?) you can't just say "write(f,number)"
   Apparently it doesn't understand that f is a file variable
   if it's a parameter, so we put it first into ftemp.
 */

void IO_WriteS(FILE *f, const long s_LOW, const long s_HIGH, Char *s)
{
    ftemp = f;
    fprintf(ftemp, "%.*s", (int)(s_HIGH - s_LOW + 1), s);
}


void IO_WritelnS(FILE *f, const long s_LOW, const long s_HIGH, Char *s)
{
    ftemp = f;
    fprintf(ftemp, "%.*s\n", (int)(s_HIGH - s_LOW + 1), s);
}


void IO_WriteI(FILE *f, long number, long ndigits)
{
    ftemp = f;
    fprintf(ftemp, "%*ld", (int)ndigits, number);
}


void IO_WriteLong(FILE *f, long number, long ndigits)
{
    ftemp = f;
    fprintf(ftemp, "%*ld", (int)ndigits, number);
}


void IO_WriteNl(FILE *f)
{
    ftemp = f;
    putc('\n', f);
}


void IO_Flush(FILE *f)
{
    fflush(f);
    P_ioresult = 0;
}


void IO_CloseIO(void)
{
}




/* End. */
