DEFINITION MODULE LinearAlgebra;

FROM DynMatrix IMPORT
    RealMatrixPtr;

PROCEDURE QrFactorizeStep1(A:    RealMatrixPtr;
			   N:    CARDINAL;
			   Work: RealArrayPtr
			   );

(* Do the first part of a QR factorization of matrix A, size N by N.
   A is the input matrix [0..N-1][0..N-1], N is the dimension, and Work is a
   variable that goes from [0..N-1].

   On output, the upper triangular part of A is "R", and the lower triangular
   part contains information needed to reconstruct Q, with the following
   routine.
 *)

PROCEDURE QrFactorizeStep2(A:	RealMatrixPtr;
			   Q:	RealMatrixPtr;
			   N:	CARDINAL;
			   Work:    RealArrayPtr
			   );
(* Given A from step 1 above, calculate Q. *)
